Subject: Re: [PATCH 2.6.9-rc2 8/8] S2io: two buffer mode

From: Chris Leech <[email-masked]>
Date: Thu, 14 Oct 2004 13:49:02 -0700

On Thu, 14 Oct 2004 11:33:13 -0700, Raghavendra Koushik
<[email-masked]> wrote:

> > 1) can this not be done with SKB fragments?
> > 
> To acheve what is required, the H/W still has to split the Rx'ed frame into
> 2 parts. By implementing this through the SKB fragments method, the only
> thing we avoid is usage of ba_0 and ba_1 fields, but note that none of these
> are allocated or freed in fast path. They are all pre-allocated buffers
> (along with the Rx descriptors) and hence won't hit the Rx side performance.
> Also by pulling down the eth_type_trans implementation partially into the
> driver any kind of copy during Rx is also avoided.

This change would pass skbs from the driver without the MAC header? 
What happens in a bridging configuration?  And dev->hard_header_parse
is set to eth_header_parse, which expects skb->mac.ethernet to be
valid, so I think any use of packet sockets will result in a NULL
dereference.

- Chris